Subject: Re: bug#66938: 30.0.50; Commit 6c47931a1ad4de ("Make EIEIO ':accessor' behave like ':reader' when reading (bug#66938)") breaks Eglot

From: João Távora <[email-masked]>
Date: Wed, 29 Nov 2023 15:01:37 +0000

merge 66938 67480
thanks

Please see bug#67480.  This has been fixed in master already, I think.
João

On Wed, Nov 29, 2023 at 2:05 AM Arsen Arsenović via Bug reports for
GNU Emacs, the Swiss army knife of text editors
<[email-masked]> wrote:
>
> Hi,
>
> The commit referenced above seems to break Eglot.  It generates the
> following stack trace:
>
> Debugger entered--Lisp error: (unbound-slot eglot-lsp-server "#<eglot-lsp-server eglot-lsp-server-156c8b8af842>" -events-buffer oref)
>   signal(unbound-slot (eglot-lsp-server "#<eglot-lsp-server eglot-lsp-server-156c8b8af842>" -events-buffer oref))
> ... ; Removing extremely long frames
>   eieio-barf-if-slot-unbound(eieio--unbound #<eglot-lsp-server eglot-lsp-server-156c8b8af842> -events-buffer oref)
>   slot-value(#<eglot-lsp-server eglot-lsp-server-156c8b8af842> -events-buffer)
>   #f(compiled-function (this) "Retrieve the slot `-events-buffer' from an object of class\n`jsonrpc-connection'." #<bytecode -0x1b11cbbb3991ccc5>)(#<eglot-lsp-server eglot-lsp-server-156c8b8af842>)
>   apply(#f(compiled-function (this) "Retrieve the slot `-events-buffer' from an object of class\n`jsonrpc-connection'." #<bytecode -0x1b11cbbb3991ccc5>) #<eglot-lsp-server eglot-lsp-server-156c8b8af842> nil)
>   jsonrpc--events-buffer(#<eglot-lsp-server eglot-lsp-server-156c8b8af842>)
>   jsonrpc-events-buffer(#<eglot-lsp-server eglot-lsp-server-156c8b8af842>)
>   jsonrpc--log-event(#<eglot-lsp-server eglot-lsp-server-156c8b8af842> (:message "Running language server: /usr/lib/llvm/17/bin/clangd"))
>   jsonrpc--debug(#<eglot-lsp-server eglot-lsp-server-156c8b8af842> "Running language server: %s" "/usr/lib/llvm/17/bin/clangd")
>   eglot--connect((c-mode c-ts-mode c++-mode c++-ts-mode objc-mode) (transient . "/tmp/") eglot-lsp-server ("/usr/lib/llvm/17/bin/clangd") ("c" "c" "c++" "c++" "objc"))
>   eglot((c-mode c-ts-mode c++-mode c++-ts-mode objc-mode) (transient . "/tmp/") eglot-lsp-server ("/usr/lib/llvm/17/bin/clangd") ("c" "c" "c++" "c++" "objc") t)
>   funcall-interactively(eglot (c-mode c-ts-mode c++-mode c++-ts-mode objc-mode) (transient . "/tmp/") eglot-lsp-server ("/usr/lib/llvm/17/bin/clangd") ("c" "c" "c++" "c++" "objc") t)
>   command-execute(eglot record)
>   execute-extended-command(nil "eglot" "eglot")
>   funcall-interactively(execute-extended-command nil "eglot" "eglot")
>   command-execute(execute-extended-command)
>
> Reproduction steps:
>
> - emacs -q
> - C-x C-f foo.c RET
> - M-x eglot RET
>
> Apologies for my brevity and lack of analysis and/or a patch - it is
> getting late.
>
> Have a lovely night.
>
> (note that the info below does not come from the emacs -q session I was
> testing this in, but I can also reproduce this issue in this session)
>
> In GNU Emacs 30.0.50 (build 1, x86_64-pc-linux-gnu, GTK+ Version
>  3.24.38, cairo version 1.18.0) of 2023-11-28 built on localhost
> Repository revision: 7a5c91a2831602c3cd961158cf0b6a876852d7ac
> Repository branch: master
> System Description: Gentoo Linux
>
> Configured using:
>  'configure --prefix=/usr --build=x86_64-pc-linux-gnu
>  --host=x86_64-pc-linux-gnu --mandir=/usr/share/man
>  --infodir=/usr/share/info --datadir=/usr/share --sysconfdir=/etc
>  --localstatedir=/var/lib --datarootdir=/usr/share
>  --disable-silent-rules --docdir=/usr/share/doc/emacs-30.0.9999
>  --htmldir=/usr/share/doc/emacs-30.0.9999/html --libdir=/usr/lib64
>  --program-suffix=-emacs-30-vcs --includedir=/usr/include/emacs-30-vcs
>  --infodir=/usr/share/info/emacs-30-vcs --localstatedir=/var
>  --enable-locallisppath=/etc/emacs:/usr/share/emacs/site-lisp
>  --without-compress-install --without-hesiod --without-pop
>  --with-file-notification=inotify --with-pdumper --enable-acl
>  --enable-xattr --with-dbus --with-modules --with-gameuser=:gamestat
>  --with-libgmp --with-gpm --with-native-compilation=aot --with-json
>  --without-kerberos --without-kerberos5 --with-lcms2 --with-xml2
>  --with-mailutils --without-selinux --without-small-ja-dic
>  --with-sqlite3 --with-gnutls --with-libsystemd --with-threads
>  --with-tree-sitter --without-wide-int --with-sound=alsa --with-zlib
>  --with-pgtk --without-x --without-ns --with-toolkit-scroll-bars
>  --without-gconf --without-gsettings --with-harfbuzz --with-libotf
>  --with-m17n-flt --with-xwidgets --with-gif --with-jpeg --with-png
>  --with-rsvg --with-tiff --with-webp --without-imagemagick
>  --with-dumping=pdumper 'CFLAGS=-freport-bug -O3 -ggdb3 -pipe
>  -fdiagnostics-color=always -march=x86-64-v2 -flto' 'LDFLAGS=-Wl,-O1
>  -Wl,--as-needed -O3 -Wl,-O3 -pipe -fdiagnostics-color=always
>  -Wl,--defsym=__gentoo_check_ldflags__=0 -Wl,-z,pack-relative-relocs
>  -Wl,--build-id -flto''
>
> Configured features:
> ACL CAIRO DBUS FREETYPE GIF GLIB GMP GNUTLS GPM HARFBUZZ JPEG JSON LCMS2
> LIBOTF LIBSYSTEMD LIBXML2 MODULES NATIVE_COMP NOTIFY INOTIFY PDUMPER
> PGTK PNG RSVG SECCOMP SOUND SQLITE3 THREADS TIFF TOOLKIT_SCROLL_BARS
> TREE_SITTER WEBP XIM XWIDGETS GTK3 ZLIB
>
> Important settings:
>   value of $LC_TIME: en_GB.UTF-8
>   value of $LANG: en_US.utf8
>   locale-coding-system: utf-8-unix
>
> Major mode: Fundamental
>
> Minor modes in effect:
>   global-git-commit-mode: t
>   magit-auto-revert-mode: t
>   TeX-PDF-mode: t
>   diff-hl-flydiff-mode: t
>   global-jinx-mode: t
>   savehist-mode: t
>   save-place-mode: t
>   desktop-save-mode: t
>   global-hl-line-mode: t
>   mu4e-modeline-mode: t
>   corfu-popupinfo-mode: t
>   global-corfu-mode: t
>   corfu-mode: t
>   marginalia-mode: t
>   vertico-mouse-mode: t
>   vertico-mode: t
>   which-key-mode: t
>   global-display-fill-column-indicator-mode: t
>   display-fill-column-indicator-mode: t
>   which-function-mode: t
>   electric-pair-mode: t
>   global-whitespace-mode: t
>   override-global-mode: t
>   tooltip-mode: t
>   global-eldoc-mode: t
>   show-paren-mode: t
>   electric-indent-mode: t
>   mouse-wheel-mode: t
>   tab-bar-mode: t
>   menu-bar-mode: t
>   file-name-shadow-mode: t
>   global-font-lock-mode: t
>   font-lock-mode: t
>   blink-cursor-mode: t
>   minibuffer-regexp-mode: t
>   column-number-mode: t
>   line-number-mode: t
>   indent-tabs-mode: t
>   transient-mark-mode: t
>   auto-composition-mode: t
>   auto-encryption-mode: t
>   auto-compression-mode: t
>
> Load-path shadows:
> /usr/share/emacs/site-lisp/cmake-mode hides /usr/share/emacs/site-lisp/cmake/cmake-mode
> /usr/share/emacs/site-lisp/desktop-entry-mode hides /usr/share/emacs/site-lisp/desktop-file-utils/desktop-entry-mode
> /usr/share/emacs/site-lisp/ninja/ninja-mode hides /usr/share/emacs/site-lisp/ninja-kitware/ninja-mode
> /usr/share/emacs/site-lisp/transient/transient hides /usr/share/emacs/30.0.50/lisp/transient
>
> Features:
> (shadow emacsbug view woman man org-clock dabbrev cape completion
> image-file image-converter sort smiley gnus-cite mm-archive mail-extr qp
> textsec uni-scripts idna-mapping ucs-normalize uni-confusable
> textsec-check magit-bookmark git-rebase magit-extras
> magit-sparse-checkout magit-gitignore magit-ediff ediff ediff-merg
> ediff-mult ediff-wind ediff-diff ediff-help ediff-init ediff-util
> magit-subtree magit-patch magit-submodule magit-blame magit-stash
> magit-reflog magit-bisect magit-push magit-pull magit-fetch magit-clone
> magit-remote magit-commit magit-sequence magit-notes magit-worktree
> magit-tag magit-merge magit-branch magit-reset magit-files magit-refs
> magit-status magit package url-handlers magit-repos magit-apply
> magit-wip magit-log magit-diff smerge-mode git-commit log-edit
> magit-core magit-autorevert magit-margin magit-transient magit-process
> with-editor comp comp-cstr server magit-mode transient magit-git
> magit-base magit-section cursor-sensor face-remap shortdoc pulse
> consult-xref disass misearch multi-isearch help-fns radix-tree cl-print
> cus-start eglot external-completion jsonrpc xref ert debug backtrace
> tramp-cache time-stamp consult pcmpl-unix em-unix em-term term ehelp
> em-script em-prompt em-pred em-ls em-hist em-glob em-extpipe em-cmpl
> em-dirs em-basic em-banner em-alias esh-mode esh-var eshell esh-cmd
> esh-ext esh-opt esh-proc esh-io esh-arg esh-module esh-groups esh-util
> vertico-directory add-log tar-mode arc-mode archive-mode font-latex
> preview latex latex-flymake tex-ispell tex-style tex-mode tex-info tex
> crm texmathp texinfo texinfo-loaddefs typescript-mode mhtml-mode
> css-mode js c-ts-common conf-mode flycheck-pkgcheck meson-mode tcl
> ruby-mode cperl-mode rng-xsd xsd-regexp rng-cmpct rng-nxml rng-valid
> rng-loc rng-uri rng-parse nxml-parse rng-match rng-dt rng-util rng-pttrn
> nxml-ns nxml-mode nxml-outln nxml-rap sgml-mode facemenu nxml-util
> nxml-enc xmltok flymake-cc flymake compile warnings yaml-mode
> autoconf-mode python project pcase dired-aux make-mode ld-script m4-mode
> info cc-mode cc-fonts cc-guess cc-menus cc-cmds cc-styles cc-align
> cc-engine cc-vars cc-defs autorevert vc-git diff-hl-flydiff diff diff-hl
> log-view pcvs-util vc-dir ewoc vc vc-dispatcher diff-mode jinx
> ebuild-mode skeleton sh-script smie treesit executable
> display-line-numbers oc-basic org-element org-persist org-id org-refile
> avl-tree generator ol-eww eww url-queue mm-url ol-rmail ol-mhe ol-irc
> ol-info ol-gnus nnselect ol-docview doc-view filenotify jka-compr
> image-mode exif ol-bibtex bibtex ol-bbdb ol-w3m ol-doi org-link-doi
> savehist saveplace tramp-sh tramp trampver tramp-integration files-x
> tramp-message tramp-compat xdg shell tramp-loaddefs desktop frameset
> cus-load mu4e mu4e-org mu4e-notification notifications mu4e-main
> mu4e-view thingatpt gnus-art mm-uu mml2015 mm-view mml-smime smime
> gnutls dig gnus-sum gnus-group gnus-undo gnus-start gnus-dbus dbus
> comp-run comp-common gnus-cloud nnimap nnmail mail-source utf7 nnoo
> parse-time iso8601 gnus-spec gnus-int gnus-range gnus-win gnus nnheader
> range wid-edit mu4e-headers mu4e-compose mu4e-draft mu4e-actions
> smtpmail mu4e-search mu4e-lists mu4e-bookmarks mu4e-mark mu4e-message
> shr pixel-fill kinsoku url-file browse-url url url-proxy url-privacy
> url-expand url-methods url-history url-cookie generate-lisp-file
> url-domsuf url-util flow-fill mule-util hl-line mu4e-contacts
> mu4e-update mu4e-folders mu4e-context mu4e-query-items mu4e-server
> mu4e-modeline mu4e-vars mu4e-helpers mu4e-config mu4e-window bookmark pp
> ido message sendmail mailcap yank-media puny dired dired-loaddefs rfc822
> mml mml-sec epa derived epg rfc6068 epg-config gnus-util
> text-property-search mm-decode mm-bodies mm-encode mail-parse rfc2231
> rfc2047 rfc2045 mm-util ietf-drums mail-prsvr mailabbrev mail-utils
> gmm-utils mailheader mu4e-obsolete auth-source-pass url-parse url-vars
> auth-source eieio eieio-core password-cache modus-vivendi-tinted-theme
> modus-themes kind-icon svg-lib color svg dom xml corfu-popupinfo corfu
> orderless marginalia vertico-mouse vertico compat flycheck json map dash
> org ob ob-tangle ob-ref ob-lob ob-table ob-exp org-macro org-src
> ob-comint org-pcomplete pcomplete comint ansi-osc ansi-color org-list
> org-footnote org-faces org-entities time-date noutline outline
> ob-emacs-lisp ob-core ob-eval org-cycle org-table ol rx org-fold
> org-fold-core org-keys oc org-loaddefs find-func cal-menu calendar
> cal-loaddefs org-version org-compat org-macs format-spec which-key
> ace-window subr-x avy ring edmacro kmacro byte-opt
> display-fill-column-indicator disp-table which-func imenu elec-pair
> icons whitespace cl-macs gv cl-extra help-mode cl-seq use-package
> use-package-ensure use-package-delight use-package-diminish
> use-package-bind-key bind-key easy-mmode use-package-core cl-loaddefs
> cl-lib bytecomp byte-compile site-gentoo preview-latex ess-autoloads
> ess-generics tex-site rmc iso-transl tooltip cconv eldoc paren electric
> uniquify ediff-hook vc-hooks lisp-float-type elisp-mode mwheel
> term/pgtk-win pgtk-win term/common-win pgtk-dnd touch-screen tool-bar
> dnd fontset image regexp-opt fringe tabulated-list replace newcomment
> text-mode lisp-mode prog-mode register page tab-bar menu-bar rfn-eshadow
> isearch easymenu timer select scroll-bar mouse jit-lock font-lock syntax
> font-core term/tty-colors frame minibuffer nadvice seq simple cl-generic
> indonesian philippine cham georgian utf-8-lang misc-lang vietnamese
> tibetan thai tai-viet lao korean japanese eucjp-ms cp51932 hebrew greek
> romanian slovak czech european ethiopic indian cyrillic chinese
> composite emoji-zwj charscript charprop case-table epa-hook
> jka-cmpr-hook help abbrev obarray oclosure cl-preloaded button loaddefs
> theme-loaddefs faces cus-face macroexp files window text-properties
> overlay sha1 md5 base64 format env code-pages mule custom widget keymap
> hashtable-print-readable backquote threads xwidget-internal dbusbind
> inotify dynamic-setting font-render-setting cairo gtk pgtk lcms2
> multi-tty move-toolbar make-network-process native-compile emacs)
>
> Memory information:
> ((conses 16 1820713 3119067) (symbols 48 62485 159) (strings 32 319528 93051)
>  (string-bytes 1 11499903) (vectors 16 193722) (vector-slots 8 3684047 2741445)
>  (floats 8 936 13963) (intervals 56 100361 18396) (buffers 992 330))
> --
> Arsen Arsenović

--
João Távora